
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android系统的五种数据存储形式实例（一）_Android / iVAN</title>

    <meta name="description" content="Android系统的五种数据存储形式实例（一）_Android Android系统有五种数据存储形式,分别是文件存储.SP存储.数据库存储.contentprovider 内容提供者.网络存储.其中,前四个是本地存储.存储的类型包括简单文本.窗口状态存储.音频视频数据.XML注册文件的各种数据.各种存储形式的特点不尽相同,因此对于不同的数据类型有着固定的存储形式,本文为演示方便给出的案例基本相同,都是是采用账号登录来演示数据存储,保存账号和密码信息,下次登录时记住账号和密码.重在说明各种存储形式的原理. 文件存储: 以I/O流的形式把数据存入手机内存或SD卡">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android系统的五种数据存储形式实例（一）_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Android系统有五种数据存储形式，分别是文件存储、SP存储、数据库存储、contentprovider 内容提供者、网络存储。其中，前四个是本地存储。存储的类型包括简单文本、窗口状态存储、音频视频数据、XML注册文件的各种数据。各种存储形式的特点不尽相同，因此对于不同的数据类型有着固定的存储形式，本文为演示方便给出的案例基本相同，都是是采用账号登录来演示数据存储，保存账号和密码信息，下次登录时记住账号和密码。重在说明各种存储形式的原理。</p>
<p><strong>文件存储:</strong></p>
<p>以I/O流的形式把数据存入手机内存或SD卡，可以存储大数据，如音乐、图片或视频等。对于手机内存来说系统会根据每个应用的包名创建一个/data/data/包名/的文件夹，访问自己包名下的目录是不需要权限的，并且 Android 已经提供了非常简便的 API 可以直接去访问该文件夹。访问时可以用getFilesDir()和getCacheDir(),两个的区别是系统会自动清理后者中的内容。</p>
<p>SD卡中的文件通常位于mnt/sdcard目录下，不同生产商生产的手机这个路径可能不同。操作sd卡的时通常要判断下sd卡是否可用以及剩余空间是否足够，因为部分手机的SD卡可卸载，SD卡处于非挂载状态时，无法进行读写操作。另外一点，对SD卡的读取和写入操作均需要相应的权限，否则无法完成。获取SD卡路径的方法是Environment.getExternalStorageDirectory()，其余操作与文件存储基本类似。</p>
<p>文件存储位置：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTEucG5n.jpg"></p>
<p>SD卡存储路径：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTIucG5n.jpg"></p>
<p>数据存储在手机内存的实现方法：</p>
<pre>
package com.example.qqload;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;

import com.example.qqload_sp.R;

import android.os.Bundle;
import android.app.Activity;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.TextUtils;
import android.view.Menu;
import android.view.TextureView;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends Activity {
 private EditText et_qq;
 private EditText et_password;
 private CheckBox cb_remenber;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  et_qq = (EditText) findViewById(R.id.et_qq);
  et_password = (EditText) findViewById(R.id.et_password);
  cb_remenber = (CheckBox) findViewById(R.id.cb_remenber);
  File file = new File(getFilesDir(), "info.txt");
//  File file = new File(getCacheDir(), "info.txt"); 缓存中存放数据
  if (file.exists() &amp;&amp; file.length() &gt; 0) {
   try {
    FileInputStream fis = new FileInputStream(file);
    BufferedReader br = new BufferedReader(new InputStreamReader(
      fis));
    String line = br.readLine();
    String qq = line.split("##")[0];
    String password = line.split("##")[1];
    et_qq.setText(qq);
    et_password.setText(password);
    fis.close();
   } catch (Exception e) {
    // TODO Auto-generated catch block
    e.printStackTrace();
   }
  }
 }

 public void login(View view) {
  String qq = et_qq.getText().toString().trim();
  String password = et_password.getText().toString().trim();
  if (TextUtils.isEmpty(qq) || TextUtils.isEmpty(password)) {
   Toast.makeText(this, "密码或者用户名不能为空", 0).show();
   return;
  }
  if (cb_remenber.isChecked()) {
   File file = new File(getFilesDir(), "info.txt");
   try {
    FileOutputStream fos = new FileOutputStream(file);
    fos.write((qq + "##" + password).getBytes());
    fos.close();
    Toast.makeText(MainActivity.this, "保存成功", 0).show();
   } catch (Exception e) {
    Toast.makeText(MainActivity.this, "保存失败", 0).show();
    e.printStackTrace();
   }
  }
 }
} 
</pre>
<p>数据存储在SD卡中的实现方法：     </p>
<pre>
package com.example.qqload;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.text.Format;

import com.example.qqload_sp.R;

import android.os.Bundle;
import android.os.Environment;
import android.app.Activity;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.TextUtils;
import android.text.format.Formatter;
import android.view.Menu;
import android.view.TextureView;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends Activity {
 private EditText et_qq;
 private EditText et_password;
 private CheckBox cb_remenber;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  et_qq = (EditText) findViewById(R.id.et_qq);
  et_password = (EditText) findViewById(R.id.et_password);
  cb_remenber = (CheckBox) findViewById(R.id.cb_remenber);
  File file = new File(Environment.getExternalStorageDirectory(), "info.txt");
  if (file.exists() &amp;&amp; file.length() &gt; 0) {
   try {
    FileInputStream fis = new FileInputStream(file);
    BufferedReader br = new BufferedReader(new InputStreamReader(
      fis));
    String line = br.readLine();
    String qq = line.split("##")[0];
    String password = line.split("##")[1];
    et_qq.setText(qq);
    et_password.setText(password);
    fis.close();
   } catch (Exception e) {
    // TODO Auto-generated catch block
    e.printStackTrace();
   }
  }
 }

 public void login(View view) {
  String qq = et_qq.getText().toString().trim();
  String password = et_password.getText().toString().trim();
  if (TextUtils.isEmpty(qq) || TextUtils.isEmpty(password)) {
   Toast.makeText(this, "密码或者用户名不能为空", 0).show();
   return;
  }
  if (cb_remenber.isChecked()) {
   File file = new File(Environment.getExternalStorageDirectory(), "info.txt");
   //判断SD卡是否挂载
   if(!Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)){
    Toast.makeText(MainActivity.this, "SD卡不可用", 0).show();
    return;
   }
   //判断SD卡大小是否充足
   long size = Environment.getExternalStorageDirectory().getFreeSpace();
   String info = Formatter.formatFileSize(this, size);
   //此处存储数据较小就不进行判断
   Toast.makeText(this, "可用空间" + info, 0).show();

   try {
    FileOutputStream fos = new FileOutputStream(file);
    fos.write((qq + "##" + password).getBytes());
    fos.close();
    Toast.makeText(MainActivity.this, "保存成功", 0).show();
   } catch (Exception e) {
    Toast.makeText(MainActivity.this, "保存失败", 0).show();
    e.printStackTrace();
   }
  }
 }
}
</pre>
<p><strong>SP存储：</strong></p>
<p>SP存储本质上是一个XML文件，以键值对的形式存入手机内存中。常用于存储简单的参数设置，如登陆账号密码的存储，窗口功能状态的存储等，该存储文件位于：data/data/包名/shared_prefs文件夹中。使用的时候，首先需要通过context.getSharedPrefrences(String name,int mode)获取SharedPrefrences的实例对象，存储数据时，用SharedPrefrences的实例对象得到SharedPrefrences文件的编辑器，在编辑器中用putXxx()添加数据，之后务必用commit提交数据，否则无法获取数据。取数据时，直接用getXxx()方法。</p>
<p>sp存储自动生成xml文件，其的路径如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTMucG5n.jpg"></p>
<p>sp存储的实现方法：</p>
<pre>
package com.example.qqload;
import com.example.qqload_sp.R;

import android.os.Bundle;
import android.app.Activity;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.TextUtils;
import android.view.Menu;
import android.view.TextureView;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;
public class MainActivity extends Activity {
 private EditText et_qq;
 private EditText et_password;
 private CheckBox cb_remenber;
  private SharedPreferences sp;
 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  et_qq = (EditText) findViewById(R.id.et_qq);
  et_password = (EditText) findViewById(R.id.et_password);
  cb_remenber = (CheckBox) findViewById(R.id.cb_remenber);
  sp = this.getSharedPreferences("config", 0);
  String qq = sp.getString("qq","");
  String password = sp.getString("password","");
  et_qq.setText(qq);
  et_password.setText(password);
 }
 public void login(View view){
  String qq = et_qq.getText().toString().trim();
  String password = et_password.getText().toString().trim();
  if(TextUtils.isEmpty(qq)||TextUtils.isEmpty(password)){
   Toast.makeText(this,"密码或者用户名不能为空",0).show();
   return;
  }
  if(cb_remenber.isChecked()){
   Editor edit = sp.edit();
   edit.putString("qq",qq);
   edit.putString("password",password);
   edit.commit();
  }
 }
}
</pre>
<p><strong> 数据库存储：</strong></p>
<p>数据库所有信息都存储在单一文件内，占用内存小，并且支持基本SQL语法，是项目中经常被采用的一种数据存储方式，通常用于存储用户信息等,例如在手机上做一个学生信息管理系统。SQLite 是一款内置到移动设备上的轻量型的数据库，SQLiteOpenHelper 是Android 提供的一个抽象工具类，负责管理数据库的创建、升级工作。数据库的路径为：/data/data/应用包名/databases/数据库。如果想创建数据库，就需要自定义一个类继承SQLiteOpenHelper，然后覆写其中的抽象方法，指定数据库名、版本号。在onCreate（） 方法中通过执行sql 语句实现表的创建。如果只是创建出来该类并不会真正的去创建数据库，而是需要通过执行helper.getWritableDatabase()或者hepler.getReadableDatabase()。另外想要对创建的数据库进行增删改查的操作可以单独定义一个类实现。增删改查操作有两种方式，一是直接执行sql语句，另一个是Android自身的API实现。用数据库实现账号登录显得有些大材小用，为演示数据库的原理本文给出的案例是用数据库记录多个用户的账号和密码信息，并把最后一个账号信息回显在界面。但实际应用中很少这样做。</p>
<p>从手机文件中导出数据库文件并不可以直接打开，因此可以用可视化工具和sqlite3操作工具进行查看。这里介绍sqlite3工具的使用。具体需要的步骤如下：</p>
<p>1. 执行adb shell命令进入Linuxne内核；</p>
<p>2. 使用cd进入数据库所在的路径 cd: /data/data/应用包名/databases;</p>
<p>3. 进入数据库模式: sqlite3 数据库名.db;</p>
<p>4. 执行SQL语句       </p>
<p>Sqlite3操作演示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTQucG5n.jpg"></p>
<p>数据库存储路径：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTUucG5n.jpg"></p>
<p>数据库实现方法，先创建一个类继承SqliteOpenHelper,在类中创建数据库和表：</p>
<pre>
package com.example.qqload.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;

public class UserDBOpenhelper extends SQLiteOpenHelper {
 public UserDBOpenhelper(Context context) {
  super(context, "user.db", null, 1);
  // TODO Auto-generated constructor stub
 }
 @Override
 public void onCreate(SQLiteDatabase arg0) {
  arg0.execSQL("create table user (_id integer primary key autoincrement,name vachar(20),password varchar(20))");
 }
 @Override
 public void onUpgrade(SQLiteDatabase arg0, int arg1, int arg2) {
  // TODO Auto-generated method stub
 }
}
</pre>
<p>创建一个工具类实现对数据库的操作：</p>
<pre>
package com.example.qqload.db.dao;

import java.util.ArrayList;
import java.util.List;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import com.example.qqload.db.UserDBOpenhelper;

public class UserDao {
 private UserDBOpenhelper helper;
 public UserDao(Context context){
  helper = new UserDBOpenhelper(context);
 }
 public long add(String name,String password){
  SQLiteDatabase db = helper.getWritableDatabase();
  //用SQL语句实现增加数据的功能
  //db.execSQL("insert into user (name,passeord) values (?,?)", new Object[]{name,password});
  //android自身API实现修改功能可以有返回值
  ContentValues values =new ContentValues();
  values.put("name", name);
  values.put("password", password);
  long result = db.insert("user", null, values); //带返回值，表示添加在哪一行
  db.close();
  return result;
 }
 public List&lt;user&gt; findAll(){
  List&lt;user&gt; list =new ArrayList&lt;user&gt;();
  SQLiteDatabase db = helper.getReadableDatabase();
  //Cursor cursor = db.rawQuery("select name, password from user", null);
  Cursor cursor = db.query("user", new String[]{"name","password"}, null, null, null, null, null);
  while(cursor.moveToNext()){
   String name = cursor.getString(0);
   String password = cursor.getString(1);
   user us = new user();
   us.setName(name);
   us.setPassword(password);
   list.add(us);
  }
  cursor.close();
  db.close();
  return list;
 }
}
</pre>
<p>在主方法中实现账号登录和记录</p>
<pre>
package com.example.qqload;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.util.List;

import com.example.qqload.db.dao.UserDao;
import com.example.qqload.db.dao.user;
import com.example.qqload.R;

import android.os.Bundle;
import android.app.Activity;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.TextUtils;
import android.view.Menu;
import android.view.TextureView;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends Activity {
 private EditText et_qq;
 private EditText et_password;
 private CheckBox cb_remenber;
 private UserDao dao;
 private List&lt;user&gt; list;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  et_qq = (EditText) findViewById(R.id.et_qq);
  et_password = (EditText) findViewById(R.id.et_password);
  cb_remenber = (CheckBox) findViewById(R.id.cb_remenber);
  user u = new user();
  dao = new UserDao(MainActivity.this);
  list = dao.findAll();
  if (list.size() == 0) {
   et_qq.setText("");
   et_password.setText("");
  } else {
   System.out.println("大小：" + list.size());
   for (int i = 0; i &lt; list.size(); i++) {
    System.out.println(list.get(i).getName() + "::::" + list.get(i).getPassword());
   }
   u = list.get(list.size()-1);
   String qq = u.getName();
   String password = u.getPassword();
   et_qq.setText(qq);
   et_password.setText(password);
  }
 }

 public void login(View view) {
  String qq = et_qq.getText().toString().trim();
  String password = et_password.getText().toString().trim();
  if (TextUtils.isEmpty(qq) || TextUtils.isEmpty(password)) {
   Toast.makeText(this, "密码或者用户名不能为空", 0).show();
   return;
  }
  if (cb_remenber.isChecked()) {
   dao.add(qq, password);   //在工具类添加增加功能
   Toast.makeText(MainActivity.this, "保存成功", 0).show();
  }
 }
}
</pre>
<p>用数据库实现账号登录案例的目录结构如下所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTIwODExMzEwNTYucG5n.jpg"></p>
<p>以上就是本文的全部内容，希望对大家的学习有所帮助，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android数据存储<br />
                                    android 存储系统架构、android 存储系统、数据库系统设计实例、计算机控制系统实例、嵌入式系统的应用实例，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-25 07:15:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android%e6%95%b0%e6%8d%ae%e5%ad%98%e5%82%a8/" title="android数据存储">android数据存储</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android系统的五种数据存储形式实例（一）_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56q97z.html" rel="bookmark">Android系统的五种数据存储形式实例（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android系统有五种数据存储形式,分别是文件存储.SP存储.数据库存储.contentprovider 内容提供者.网络存储.其中,前四个是本地存储.存储的类型包括简单文本.窗口状态存储.音频视频数据.XML注册文件的各种数据.各种存储形式的特点不尽相同,因此对于不同的数据类型有着固定的存储形式,本文为演示方便给出的案例基本相同,都是是采用账号登录来演示数据存储,保存账号和密码信息,下次登录时记住账号和密码.重在说明各种存储形式的原理. 文件存储: 以I/O流的形式把数据存入手机内存或SD卡			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj25x6b.html" rel="bookmark">Android系统的五种数据存储形式实例（二）&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前介绍了Android系统下三种数据存储形式,http://www.jb51.net/article/99468.htm.今天补充介绍另外两种,分别是内容提供者和网络存储.有些人可能认为内存提供者和网络存储更偏向于对数据的操作而不是数据的存储,但这两种方式确实与数据有关,所以这里还是将这两种形式简要的说明一下.  Content Provider: Content Provider,中文名是内存提供者,Android四大组件之一,内容提供者是应用程序之间共享数据的接口,以数据库形式存入手机内存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9X5k3b.html" rel="bookmark">Android系统的五种数据存储形式实例（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前介绍了Android系统下三种数据存储形式,http://www.jb51.net/article/99468.htm.今天补充介绍另外两种,分别是内容提供者和网络存储.有些人可能认为内存提供者和网络存储更偏向于对数据的操作而不是数据的存储,但这两种方式确实与数据有关,所以这里还是将这两种形式简要的说明一下. Content Provider: Content Provider,中文名是内存提供者,Android四大组件之一,内容提供者是应用程序之间共享数据的接口,以数据库形式存入手机内存,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZVm0z.html" rel="bookmark">Android系统中的蓝牙连接程序编写实例教程&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Bluetooth结构1.JAVA层 frameworks/base/core/java/android/bluetooth/ 包含了bluetooth的JAVA类. 2.JNI层 frameworks/base/core/jni/android_bluetooth_开头的文件 定义了bluez通过JNI到上层的接口. frameworks/base/core/jni/android_server_bluetoothservice.cpp 调用硬件适配层的接口system/bluetooth/b			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YekBz.html" rel="bookmark">五维数据存储技术：容量可达蓝光3000倍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				英国南安普顿大学科学家近日开发出一种新的数据存储技术,利用玻璃中的微型纳米结构来编码信息.基于这一技术,标准尺寸光碟能保存约360TB的数据,而在温度高达190摄氏度的环境中可维持长达138亿年.这一时间与宇宙的历史相仿,达到地球年龄的3倍. 这一技术被称作&quot;五维数据存储&quot;,最初发表在2013年的一篇论文中.自那时以来,科学家仍在继续对该技术进行优化.目前,科学家计划进一步推动这项技术的发展,甚至实现商用. 为了展示这一数据存储技术的优势,南安普顿大学团队将英皇钦定本圣经.牛顿的&lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoYaGb.html" rel="bookmark">3d 三维模型-如何在Android系统利用三维矩阵数据生成三维面形</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何在Android系统利用三维矩阵数据生成三维面形 即在android系统中实现类似于matlab中的mesh函数的功能 解决方案 你试试Unity-3d吧!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd7883M.html" rel="bookmark">iOS网络编程入门：iCloud键值数据存储编程实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iCloud键值数据存储设计 iCloud键值数据存储编程实例,画面中有两个开关控件,左图是设备1点击&quot;设置iCloud数据&quot;按钮,将控件状态保存到iCloud服务器.右图是设备2画面,过几秒钟后设备2收到变更通知. 配置Xcode工程 使用Xcode创建一个iOS工程,工程创建好之后,选择TAGETS→MyNotes→Summary→Entitlements,我们可以在这里配置授权信息. 然后我们还需要应用设置代码签名标识,代码签名标识需要选择这个配置概要文件的.选择TAGETS→M			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Y2LOb.html" rel="bookmark">iOS网络编程-iCloud键值数据存储编程实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iCloud键值数据存储设计 iCloud键值数据存储编程实例,画面中有两个开关控件,左图是设备1点击&quot;设置iCloud数据&quot;按钮,将控件状态保存到iCloud服务器.右图是设备2画面,过几秒钟后设备2收到变更通知.     配置Xcode工程 使用Xcode创建一个iOS工程,工程创建好之后,选择TAGETS→MyNotes→Summary→Entitlements,我们可以在这里配置授权信息. 然后我们还需要应用设置代码签名标识,代码签名标识需要选择这个配置概要文件的.选择TAGE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NYqjz.html" rel="bookmark">Android编程中的5种数据存储方式&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍Android平台进行数据存储的五大方式,分别如下: 1 使用SharedPreferences存储数据 2 文件存储数据      3 SQLite数据库存储数据 4 使用ContentProvider存储数据 5 网络存储数据 下面详细讲解这五种方式的特点 第一种: 使用SharedPreferences存储数据 适用范围:保存少量的数据,且这些数据的格式非常简单:字符串型.基本类型的值.比如应用程序的各种配置信息(如是否打开音效.是否使用震动效果.小游戏的玩家积分等),解锁口 令密			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9j1vp.html" rel="bookmark" class="title">PS文字特效教程&colon;漂亮的绿色立体春天文字特效</a>
					<div>
						立体字教程,我在本版发过很多,今天的教程,主要介绍了石头字的做法,另外大家也可以通过这个教程学到绚丽的光芒效果和一些纹理制作,藤蔓大家可以自由发挥,或是用真实的素材来做也可以.总之,只要你有想象力没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn4ekb.html" rel="bookmark" class="title">linux基础命令&lpar;17&rpar; whereis命令</a>
					<div>
						whereis命令只能用于程序名的搜索,而且只搜索二进制文件(参数-b). man说明文件(参数-m)和源代码文件(参数-s).如果省略参数,则返回所有 信息. 和find相比,whereis查找的速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXQLLz.html" rel="bookmark" class="title">Eclipse快速上手Hibernate--3&period; 利用XDoclet开发</a>
					<div>
						    这篇文章是上两篇文章&lt;Eclipse快速上手Hibernate--1. 入门实例&gt;和&lt;Eclipse快速上手Hibernate--2. 利用Hbm映射文件开发&gt;的延续, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3Gx0b.html" rel="bookmark" class="title">Visual Basic 6&sol;VBScript 與Visual Basic&period;NET 的比較&lpar;下&rpar;</a>
					<div>
						vbscript|visual 新的簡易設定(assignment)語法 Visual Basic.NET 提供新的簡易設定語法,當程式碼撰寫如下時   MyVal = 10 MyVal += 10  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeO0NM.html" rel="bookmark" class="title">外链是怎么炼成的  一个SEOer的经验分享</a>
					<div>
						网站优化,无非是内部优化和外部优化,两种方式相结合,只要网站内部结构组织好,保持文章内容的原创度,持续更新,然后再加上持之以恒的外部链接建设,那么你的网站一定不会差到哪里去,那么外链是怎么炼成的呢?这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm8olM.html" rel="bookmark" class="title">网站优化时如何对图片进行优化</a>
					<div>
						在网站优化中,其实图片的优化也占了很大一部分,它是SEO优化中重要的一个组成部分,图片优化得好,不但可以提高页面的加载速度,加快搜索引擎的抓取速度以至于收录更多页面,而且通过对图片进行有意识的优化,还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZo4Vz.html" rel="bookmark" class="title">win7系统怎么为记事本输入加入下划线</a>
					<div>
						  1.首先,咱们同时按下win7旗舰版电脑键盘上的win+R快捷键打开电脑的运行窗口,在打开的运行窗口中,咱们输入regedit并单击回车,这样就可以打开win7旗舰版系统的注册表编辑器窗口了.   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6kG2b.html" rel="bookmark" class="title">ios-NSDateFormatter错误返回一年前日期</a>
					<div>
						问题描述 NSDateFormatter错误返回一年前日期 代码: NSString *ds = @&quot;2013-02-25&quot;; NSDateFormatter* formatter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N3D8M.html" rel="bookmark" class="title">线性表的顺序存储</a>
					<div>
						参考自:http://blog.csdn.net/u010187139/article/details/46659943 // // main.c // SqlListDemo //对其改变的传地址, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWyDrp.html" rel="bookmark" class="title">trunk中是eclipse项目，branch是android studio项目，怎么merge？</a>
					<div>
						问题描述 trunk中是eclipse项目,branch是android studio项目,怎么merge? 第一:trunk中是eclipse项目,branch里面是由eclipse项目生成的and ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW8Bvp.html" rel="bookmark" class="title">&lbrack;Android&rsqb;Android中R文件的丢失问题</a>
					<div>
						R.java这个文件是会自动生成的.但是有时候你写错xml文件的时候,R.java是不会自动生成对应的值.这个时候我们会很习惯去clean一下这个项目,这个时候会突然发现,R.java竟然不见了. 这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWAe5z.html" rel="bookmark" class="title">autocad2008 字库-关于autocad2008字库问题</a>
					<div>
						问题描述 关于autocad2008字库问题 为什么autocad2008不能一次性安装成功,还需要字库. 解决方案 如果AutoCAD2008在桌面显示,你右键单击图标,属性,查找目录.弹出安装目录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Zjnrp.html" rel="bookmark" class="title">Fragment界面空白，按钮可按</a>
					<div>
						问题描述 用的是Fragment.1.点击程序主页上的某个功能后进入.2.返回主页,主页变成空白的了.3.猜着点主页上的按钮位置,还可以进入功能页面.以上情况偶尔发生,请了解的高手不吝赐教. 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB0Z4z.html" rel="bookmark" class="title">Core Data 版本迁移经验总结</a>
					<div>
						大家在学习和使用Core Data过程中,第一次进行版本迁移的经历一定是记忆犹新,至少我是这样的,XD.弄的不好,就会搞出一些由于迁移过程中数据模型出错导致的Crash.这里总结了一下Core Dat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqLl7p.html" rel="bookmark" class="title">GeneDock协助诊断基层地区的听力障碍儿童 &num;科技有温度&num;</a>
					<div>
						基因诊断 让先天性耳聋的孩子聆听世界 耳聋是一大类遗传性疾病,先天性耳聋不仅严重影响患者生活质量,且治疗与康复训练成本昂贵,我国作为世界人口大国,所面临的聋病问题尤为突出.GeneDock与西南医院合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrEr2p.html" rel="bookmark" class="title">Virpus西雅图Xen SSD方案VPS主机配置、速度及性能稳定体验</a>
					<div>
						我们在是上周末的时候应该都有看到关于Virpus商家推出夏季SSD固态硬盘Linux/Windows VPS主机的二五折促销活动.关于Virpus商家的用户口碑在被收购之前并不是很好,而且还不支持退款 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWKQEz.html" rel="bookmark" class="title">Python图算法实例分析&lowbar;python</a>
					<div>
						本文实例讲述了Python图算法.分享给大家供大家参考,具体如下: #encoding=utf-8 import networkx,heapq,sys from matplotlib import p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0JK7z.html" rel="bookmark" class="title">重写javascript中window&period;confirm的行为&lowbar;javascript技巧</a>
					<div>
						javascript中window.confirm这个方法很好用,可以弹出一个确认对话框我们之所以弹出这个对话框,可能就是因为该操作很危险,所以要用户确认.但如果默认选择&quot;确定&quot;, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWELRz.html" rel="bookmark" class="title">MySQL数据库常用操作和技巧&lpar;DBA必备知识&rpar;&lowbar;Mysql</a>
					<div>
						MySQL数据库可以说是DBA们最常见和常用的数据库之一,MySQL的广泛应用,也使更多的人加入到学习它的行列之中.下面是老MySQL DBA总结的MySQL数据库最常见和最常使用的一些经验和技巧,分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8rVdp.html" rel="bookmark" class="title">电子阅读狂飙突进：版权与盈利模式成焦点</a>
					<div>
						&lt;中国经济周刊&gt;记者 张伟 | 北京报道 2009年,数字出版业发展迅猛,其总产值首度超越传统书报刊出版物,高达795亿元人民币.随着数字出版技术的日益成熟,全球范围内数字出版的竞争越来越 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKvmOz.html" rel="bookmark" class="title">EF里Guid类型数据的自增长、时间戳和复杂类型的用法</a>
					<div>
						原文:EF里Guid类型数据的自增长.时间戳和复杂类型的用法 通过前两章Lodging和Destination类的演示,大家肯定基本了解Code First是怎么玩的了,本章继续演示一些很实用的东西. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkrV0p.html" rel="bookmark" class="title">c&plus;&plus; 选择排序-用选择排序的方法对一个有超过100万的数组进行排序</a>
					<div>
						问题描述 用选择排序的方法对一个有超过100万的数组进行排序 我想请教大家,老师让我们用选择排序来对一个有2^20个元素和一个有2^24个元素的数组进行排序并且计算总的操作数.我利用堆分配和教材上的选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0ma7M.html" rel="bookmark" class="title">语言樊篱能否被互联网所打破</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 1988年,高钢在美国以访问学者的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmd07b.html" rel="bookmark" class="title">OUTLINE&amp;EVOLUTION隆胸注入物破裂惨痛教训</a>
					<div>
						七年前,年仅18岁的兰小姐(化名)在美容院小姐的怂恿下,接受了注射隆胸.三年来,她饱受乳房变形.胸部隐痛的折磨,甚至夏天不能穿紧身衣和游泳衣--近日,她接受了注射物取出手术,医生惊讶地发现:她两侧胸部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdQjxb.html" rel="bookmark" class="title">索尼音乐中国总经理黄小茂离职尚无人接替</a>
					<div>
						黄小茂(资料图片) 本报讯 (记者康沛)昨日记者获悉,原任索尼音乐中国区总经理的黄小茂已于春节前正式离职,改任索尼音乐大中华区总裁崔震东的&quot;特别顾问&quot;一职.据索尼音乐工作人员孙女士 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRPoqz.html" rel="bookmark" class="title">csharp&colon; Oracle Metadata queries</a>
					<div>
						数据类型表: TypeName ProviderDbType ColumnSize CreateFormat CreateParameters DataType BFILE 1 4294967296  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoJvnM.html" rel="bookmark" class="title">深圳警方破获境内外勾结涉案150万元电话诈骗案</a>
					<div>
						[本报讯](记者 徐 恬 通讯员 隆啸啸 胡常旋)同乐检查站近期协助警方破获一个境内外勾结.涉案150万余元的电话诈骗案,抓获犯罪嫌疑人21名. 6月2日上午,深圳经济特区同乐检查站执勤官兵对一辆车牌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenkX9b.html" rel="bookmark" class="title">微信公众平台开发（36）疯狂猜图</a>
					<div>
						微信公众平台开发 微信公众平台开发模式 微信公众平台 企业微信公众平台 微信疯狂猜图作者:方倍工作室 原文: http://www.cnblogs.com/txw1958/archive/2013/0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqWdXp.html" rel="bookmark" class="title">【ANDROID游戏开发十五】关于ANDROID 游戏开发中 ONTOUCHEVENT&lpar;&rpar; 触屏事件的性能优化笔记！</a>
					<div>
						本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/336.html  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M191yrM.html" rel="bookmark" class="title">思科30个市场并进四面撒网战略遭质疑</a>
					<div>
						导语:美国&lt;商业周刊&gt;网络版今日发表分析文章称,思科董事长兼CEO钱伯斯正面临着巨大的挑战,如何让规模如此庞大的公司继续保持迅猛增长和行动迅速.如今思科面临着30个不同的市场,钱伯斯为思科 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
